/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.deken.game.component;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import org.deken.game.graphics.GameGFX;
import org.deken.game.sprites.SpriteSize;

/**
 * <p>Title: GameText</p>
 *
 * <p>Description: Utility for Texts.</p>
 *
 * <p>Copyright: Copyright (c) Mar 17, 2011</p>
 *
 * @author Gary Deken<
 * @version 1.0
 */
public class GameText implements Cloneable {
   private String text;
   private Font font;
   private Color fontColor;
   private Color backgroundColor;
   private int textOffset;
   private SpriteSize size;
   private boolean invalid = false;

   /**
    * 
    * @param text
    * @param font
    * @param fontColor
    */
   public GameText(String text, Font font, Color fontColor) {
      this.text = text;
      this.font = font;
      this.fontColor = fontColor;
      invalid = true;
   }

   /**
    *
    * @return size
    */
   public SpriteSize getSize() {
      return size;
   }

   public Font getFont() {
      return font;
   }

   public Color getFontColor() {
      return fontColor;
   }

   public Color getBackgroundColor() {
      return backgroundColor;
   }

   public String getText() {
      return text;
   }

   public int getTextOffset() {
      return textOffset;
   }

   public boolean isInvalid() {
      return invalid;
   }

   public void setBackgroundColor(Color backgroundColor) {
      this.backgroundColor = backgroundColor;
   }

   public void setFont(Font font) {
      this.font = font;
      invalid = true;
   }

   public void setFontColor(Color fontColor) {
      this.fontColor = fontColor;
   }

   public void setText(String text) {
      this.text = text;
      invalid = true;
   }

   public void setInvalid(boolean invalid) {
      this.invalid = invalid;
   }

   /**
    * Uses the current graphics object to get FontMetrics and the size of the text.
    */
   public void validate() {
      FontMetrics fontMetrics = GameGFX.gfx().getFontMetrics(this.font);
      // get size for string and font.
      size = new SpriteSize(fontMetrics.getHeight(), fontMetrics.stringWidth(text));
      textOffset = fontMetrics.getMaxAscent();
      invalid = false;
   }

   @Override
   protected Object clone() {
      GameText that = new GameText(this.text, this.font, this.fontColor);
      that.invalid = true;
      return that;
   }


}
